#!/bin/bash

function install_packages() {
    clear
    echo "================="
    echo "Установка пакетов"
    echo "================="
    sudo apt-get install $PKGSTOINSTALL
}


clear
DATE=`echo $(date +%Y-%m-%d)`
TIME=`echo $(date +%H-%M)`
DATETIME=$DATE-$TIME

PKGSTOINSTALL=""

echo "======================================="
echo "Проверка: установлены ли нужные пакеты:"
echo "======================================="
echo

BUILD_ESSENTIAL="$(dpkg -l | grep build-essential)"
if [ -z "$BUILD_ESSENTIAL" ]; then
BUILD_ESSENTIAL="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL"build-essential"
else 
BUILD_ESSENTIAL="Установлен"
fi
echo "Пакет build-essential	:$BUILD_ESSENTIAL"

AUTOCONF="$(dpkg -l | grep autoconf)"
if [ -z "$AUTOCONF" ]; then
AUTOCONF="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" autoconf"
else
AUTOCONF="Установлен"
fi
echo "Пакет autoconf		:$AUTOCONF"

AUTOMAKE="$(dpkg -l | grep automake)"
if [ -z "$AUTOMAKE" ]; then
AUTOMAKE="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" automake"
else
AUTOMAKE="Установлен"
fi
echo "Пакет automake		:$AUTOMAKE"

MYSQL_SERVER="$(dpkg -l | grep mysql-server)"
if [ -z "$MYSQL_SERVER" ]; then
MYSQL_SERVER="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" mysql-server"
else
MYSQL_SERVER="Установлен"
fi
echo "Пакет mysql-server	:$MYSQL_SERVER"

MYSQL_CLIENT="$(dpkg -l | grep mysql-client)"
if [ -z "$MYSQL_CLIENT" ]; then
MYSQL_CLIENT="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" mysql-client"
else
MYSQL_CLIENT="Установлен"
fi
echo "Пакет mysql-client	:$MYSQL_CLIENT"

GIT="$(dpkg -l | grep 'GNU Interactive Tools')"
if [ -z "$GIT" ]; then
GIT="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" git"
else
GIT="Установлен"
fi
echo "Пакет git		:$GIT"

GIT_CORE="$(dpkg -l | grep git-core)"
if [ -z "$GIT_CORE" ]; then
GIT_CORE="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" git-core"
else
GIT_CORE="Установлен"
fi
echo "Пакет git-core		:$GIT_CORE"

SVN="$(dpkg -l | grep subversion)"
if [ -z "$SVN" ]; then
SVN="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" subversion"
else
SVN="Установлен"
fi
echo "Пакет subversion	:$SVN"

LIBMYSQL_DEV="$(dpkg -l | grep libmysql++-dev)"
if [ -z "$LIBMYSQL_DEV" ]; then
LIBMYSQL_DEV="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" libmysql++-dev"
else
LIBMYSQL_DEV="Установлен"
fi
echo "Пакет libmysql++-dev	:$LIBMYSQL_DEV"

LIBSSL_DEV="$(dpkg -l | grep libssl-dev)"
if [ -z "$LIBSSL_DEV" ]; then
LIBSSL_DEV="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" libssl-dev"
else
LIBSSL_DEV="Установлен"
fi
echo "Пакет libssl-dev     	:$LIBSSL_DEV"

LIBTOOL_DEV="$(dpkg -l | grep libtool)"
if [ -z "$LIBTOOL_DEV" ]; then
LIBTOOL_DEV="Не установлен"
PKGSTOINSTALL=$PKGSTOINSTALL" libtool"
else
LIBTOOL_DEV="Установлен"
fi
echo "Пакет libtool     	:$LIBTOOL_DEV"


if [ -n "$PKGSTOINSTALL" ]; then
    echo 
    echo "Проверка показала что некоторые пакеты не установлены."
    echo "Необходимо установить следующие пакеты:"
    echo
    echo "$PKGSTOINSTALL"
    echo


    while true; do
        read -s -n1 -p "Установить пакеты ? (y/n) [n]" key
        if [ "$key" = "" -o "$key" = "n" -o "$key" = "N" ]; then
    	    key="No"
	    exit 0
        elif [ "$key" = "y" -o "$key" = "Y" ]; then
	    key="Yes"
	    break
	else
	    echo " Ошибка ввода, повторите ввод!"
	fi
    done

    if [ "$key" = "Yes" ]; then
	install_packages
    fi
fi

echo
echo "Все необходимые пакеты установлены, можно переходить к загрузке исходных кодов и сборке сервера"

while true; do
    read -s -n1 -p "Продолжить и начать загрузку исходных кодов ? (y/n) [n]" key
    if [ "$key" = "" -o "$key" = "n" -o "$key" = "N" ]; then
        key="No"
        exit 0
    elif [ "$key" = "y" -o "$key" = "Y" ]; then
        key="Yes"
	break
    else
	echo " Ошибка ввода, повторите ввод!"
    fi
done

clear
echo "======================================="
echo "Проверка и создание структуры каталогов"
echo "======================================="
echo

cd $HOME
MAINSRCDIR="$(ls | grep Mangos-Sources)"

if [ -n "$MAINSRCDIR" ]; then
    echo "Корневой каталог исходных кодов - Mangos-Sources	:Существует"
else
    MAINSRCDIR="Mangos-Sources"
    if mkdir "$MAINSRCDIR"; then
	echo "Корневой каталог исходных кодов - Mangos-Sources	:Создан"
    else
	echo "Корневой каталог исходных кодов - Mangos-Sources	:Не удалось создать"
	exit
    fi
fi

cd $MAINSRCDIR

MANGOSSRCDIR="$(ls | grep mangos)"
if [ -n "$MANGOSSRCDIR" ]; then
    echo "Каталог исходных кодов Mangos - mangos			:Существует"
    MANGOSSRCDIR="mangos"
else
    echo "Каталог исходных кодов Mangos - mangos 			:Будет создан при загрузке исходных кодов"
fi

SD2SRCDIR="$(ls | grep scripts)"
if [ -n "$SD2SRCDIR" ]; then
    echo "Каталог исходных кодов ScriptDev2 - scripts		:Существует"
    SD2SRCDIR="scripts"
else
    echo "Каталог исходных кодов ScriptDev2 - scripts           :Будет создан при загрузке исходных кодов"
fi

echo
echo "=============================="
echo "Загружаем исходные коды Mangos" 
echo "=============================="
echo 

if [ "$MANGOSSRCDIR" != "mangos" ]; then
    echo "Загружаем исходные коды Mangos из репозитария GIT"
    cd "$HOME/$MAINSRCDIR"
    git clone git://github.com/mangos/mangos.git
    MANGOSSRCDIR="mangos"
else
    echo "Обновляем исходные коды Mangos из репозитария GIT"
    cd "$HOME/$MAINSRCDIR/$MANGOSSRCDIR"
    git pull origin master
fi

cd $HOME

MANGOSREVSTR="$(grep [0-9] $HOME/Mangos-Sources/mangos/src/shared/revision_nr.h)"
POS="$(expr index "$MANGOSREVSTR" '"')"
MANGOS_REVISION="${MANGOSREVSTR:POS:4}"

echo
echo "=================================="
echo "Загружаем исходные коды ScriptDev2" 
echo "=================================="
echo 

if [ "$SD2SRCDIR" != "scripts" ]; then
    SD2SRCDIR="scripts"
    echo "Загружаем исходные коды ScriptDev2 из репозитария SVN"
    mkdir "$HOME/$MAINSRCDIR/$SD2SRCDIR"
    cd "$HOME/$MAINSRCDIR/$SD2SRCDIR"
    svn co http://scriptdev2.svn.sourceforge.net/svnroot/scriptdev2 $HOME/$MAINSRCDIR/$SD2SRCDIR
else
    echo "Обновляем исходные коды ScriptDev2 из репозитария SVN"
    cd "$HOME/$MAINSRCDIR/$SD2SRCDIR"
    svn up
fi

cd $HOME/$MAINSRCDIR/$SD2SRCDIR

SD2REVSTR="$(svn info | grep 'Редакция: ')"
SD2_REVISION="${SD2REVSTR:(-3)}"

echo
echo "================================================="
echo "Редакция исходных кодов Mangos	: $MANGOS_REVISION"
echo "Редакция исходных кодов ScriptDev2: $SD2_REVISION"
echo "================================================"
echo 
echo "Выполняем поиск патча для сборки со скриптами:"

cd "$HOME/$MAINSRCDIR/$SD2SRCDIR/patches"

MAX_FILE_VER="0000"
PATCHFILE=""
for I in *.patch; do
    FILE="$(ls "$I")"
    CUR_FILE_VER=${FILE:`expr index "$FILE" "-"`:4}
    if [[ "$CUR_FILE_VER" > "$MAX_FILE_VER" ]]; then
	MAX_FILE_VER=$CUR_FILE_VER
	PATCHFILE=$FILE
    fi
done

echo "Последняя версия патча: $PATCHFILE"
echo

cd $HOME/$MAINSRCDIR/$MANGOSSRCDIR
ALREADYHAVETHISPATCH="$(ls | grep $PATCHFILE)"

if [ -z $ALREADYHAVETHISPATCH ]; then

    while true; do
	read -s -n1 -p "Выполнить применение патча ? (y/n) [n]" key
	if [ "$key" = "" -o "$key" = "n" -o "$key" = "N" ]; then
    	    key="No"
    	    echo
    	    echo "Сборка будет выполняться без поддержки ScriptDev2"
    	    WITHOUTSD2=true
    	    break
	elif [ "$key" = "y" -o "$key" = "Y" ]; then
    	    key="Yes"
	    break
	else
	    echo
	    echo " Ошибка ввода, повторите ввод!"
	fi
    done

    echo
    if [[ "$key" = "Yes" ]]; then
	cd $HOME/$MAINSRCDIR/$MANGOSSRCDIR
	git am < $HOME/$MAINSRCDIR/$SD2SRCDIR/patches/$PATCHFILE
	touch ./$PATCHFILE"ed"
    fi

else
    echo "Найденный патч уже применялся!"
fi

echo
echo "===================================="
echo "Выполняем перенос в папку для сборки"
echo "===================================="
echo

cd $HOME/$MAINSRCDIR

COMPILEDIR="compile"
THISCOMPDIR="compile-$MANGOS_REVISION-$SD2_REVISION"

if [[ -z "$(ls | grep $COMPILEDIR)" ]]; then
    echo "Создаем папку для копирования исходников перед компиляцией"
    mkdir $COMPILEDIR
fi

cd $COMPILEDIR

if [[ -z "$(ls | grep $THISCOMPDIR)" ]]; then
    echo "Создаем папку для копирования исходников текущей ревизии - $THISCOMPDIR"
    mkdir $THISCOMPDIR
else
    echo "Очищаем папку для копирования исходников текущей ревизии - $THISCOMPDIR"
    rm -rf $HOME/$MAINSRCDIR/$COMPILEDIR/$THISCOMPDIR/*
fi

echo "Копируем исходные тексты с учетом структуры расположения ScriptDev2"

cp $HOME/$MAINSRCDIR/$MANGOSSRCDIR/* $HOME/$MAINSRCDIR/$COMPILEDIR/$THISCOMPDIR -f -r
mkdir $HOME/$MAINSRCDIR/$COMPILEDIR/$THISCOMPDIR/src/bindings/ScriptDev2
cp $HOME/$MAINSRCDIR/$SD2SRCDIR/* $HOME/$MAINSRCDIR/$COMPILEDIR/$THISCOMPDIR/src/bindings/ScriptDev2 -f -r

BINARYDIR="Mangos-Server"
THISBINARYDIR="mangos-$MANGOS_REVISION-$SD2_REVISION"

cd $HOME

if [[ -z "$(ls | grep $BINARYDIR)" ]]; then
    echo "Создаем папку для размещения исполняемых файлов сервера"
    mkdir $BINARYDIR
fi

cd $BINARYDIR

if [[ -z "$(ls | grep $THISBINARYDIR)" ]]; then
    echo "Создаем папку для размещения сервера текущей ревизии - $THISBINARYDIR"
    mkdir $THISBINARYDIR
else
    echo "Папка для размещения текущей ревизии - $THISBINARYDIR - существует"
fi

cd $HOME/$MAINSRCDIR/$COMPILEDIR/$THISCOMPDIR

echo 
echo "============================"
echo "Выполняем реконфигурирование"
echo "============================"
echo 

autoreconf -fvi

echo 
echo "====================================================================="
echo "Создаем папку для выполнения скрипта конфигурирования и запускаем его"
echo "====================================================================="
echo 


mkdir objdir
cd objdir

../configure --prefix=$HOME/$BINARYDIR/$THISBINARYDIR --sysconfdir=$HOME/$BINARYDIR/config --datadir=$HOME/$BINARYDIR/sql --with-python --enable-cli

echo 
echo "===================================="
echo "Запускаем сборку и установку сервера"
echo "===================================="
echo 

make && make install

echo 
echo "================"
echo "Сборка завершена"
echo "================"
echo 
echo "Собран сервер редакции $MANGOS_REVISION с поддержкой скриптов версии $SD2_REVISION"
echo "Сервер размещен в папке $BINARYDIR/$THISBINARYDIR"
echo "С Вами был Alex Blade, удачи!!"
echo 
echo "================"

exit 0